
#import "ViewController.h"
#import <AVFoundation/AVFoundation.h>

@interface ViewController ()
@property (weak, nonatomic) IBOutlet UIImageView *imageView;

@end

@implementation ViewController

- (void)viewDidLoad {
  [super viewDidLoad];
}

- (IBAction)open:(id)sender {
  UIButton *button = [[UIButton alloc] initWithFrame:CGRectMake(50, 50, 200, 44)];
  [button setTitle:@"Capture Screen shot" forState:UIControlStateNormal];
  [button addTarget:self action:@selector(takeScreenshot) forControlEvents:UIControlEventTouchUpInside];
  button.backgroundColor = [UIColor grayColor];
  
  picker = [[UIImagePickerController alloc] init];
  picker.delegate = self;
  picker.allowsEditing = NO;
  picker.sourceType = UIImagePickerControllerSourceTypeCamera;
  picker.showsCameraControls = NO;
  picker.cameraOverlayView = button;
  
  [self presentViewController:picker animated:YES completion:NULL];
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
  
  //UIImage *chosenImage = info[UIImagePickerControllerEditedImage];
  //self.imageView.image = chosenImage;
  
  [picker dismissViewControllerAnimated:YES completion:NULL];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
  [picker dismissViewControllerAnimated:YES completion:NULL];
  
}

- (void)didReceiveMemoryWarning {
  [super didReceiveMemoryWarning];
  // Dispose of any resources that can be recreated.
}

- (void)takeScreenshot {
   // 1.
  CGSize imageSize = [[UIScreen mainScreen] bounds].size;
  UIGraphicsBeginImageContextWithOptions(imageSize, YES, 0);
  
  CGContextRef context = UIGraphicsGetCurrentContext();
  
  // Iterate over every window from back to front
  for (UIWindow *window in [[UIApplication sharedApplication] windows]) {
    if (![window respondsToSelector:@selector(screen)] || [window screen] == [UIScreen mainScreen]) {
      // -renderInContext: renders in the coordinate space of the layer,
      // so we must first apply the layer's geometry to the graphics context
      CGContextSaveGState(context);
      // Center the context around the window's anchor point
      CGContextTranslateCTM(context, [window center].x, [window center].y);
      // Apply the window's transform about the anchor point
      CGContextConcatCTM(context, [window transform]);
      // Offset by the portion of the bounds left of and above the anchor point
      CGContextTranslateCTM(context,
                            -[window bounds].size.width * [[window layer] anchorPoint].x,
                            -[window bounds].size.height * [[window layer] anchorPoint].y);
      
      // Render the layer hierarchy to the current context
      if ([window respondsToSelector:@selector(drawViewHierarchyInRect:afterScreenUpdates:)]) {
        [window drawViewHierarchyInRect:[window bounds] afterScreenUpdates:NO];
      } else {
        [[window layer] renderInContext:context];
      }
      
      // Restore the context
      CGContextRestoreGState(context);
    }
  }
  
  // Retrieve the screenshot image
  UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
  
  UIGraphicsEndImageContext();
  
  /* // 2.
  UIImage *image;
  UIGraphicsBeginImageContext(self.view.frame.size);
  [self.view drawViewHierarchyInRect:self.view.frame afterScreenUpdates:YES];
  image = UIGraphicsGetImageFromCurrentImageContext();
  UIGraphicsEndImageContext();
   */
  [picker dismissViewControllerAnimated:YES completion:NULL];
  self.imageView.image = image;
}

@end
